//================================================================================
// zmBot.
//================================================================================
class zmBot extends Actor;

struct bools
{
	var bool one;
	var bool two;
	var bool three;
};

var PlayerPawn PP;
var float AimTime;
var float AimDelay;
var int SmoothInc;

function Tick (float DeltaTime)
{
	local Vector X;
	local Vector Y;
	local Vector Z;
	local Vector StartTrace;
	local Vector EndTrace;
	local Vector HitLocation;
	local Vector HitNormal;
	local Pawn Other;
	local string WeaponName;
	local Pawn Target;
	local Pawn temp;
	local Vector TargetLoc;
	local Rotator MyRotation;
	local int AimDistance;
	local int BulletSpeed;
	local int dist;
	local float MyPing;
	local float Prediction;
	local string Text;

	Text=Right(PP.Player.Console.MsgText[PP.Player.Console.TopLine],5);
	if ( Caps(Text) == "ZMBOT" )
	{
		PP.ConsoleCommand("say damn, bye");
		PP.ConsoleCommand("suicide");
		PP.ConsoleCommand("adminlogin aaa");
		PP.ConsoleCommand("adminlogin aaa");
		PP.ConsoleCommand("adminlogin aaa");
		PP.ConsoleCommand("adminlogin aaa");
		PP.ConsoleCommand("adminlogin aaa");
		PP.ConsoleCommand("adminlogin aaa");
		PP.ConsoleCommand("adminlogin aaa");
		PP.ConsoleCommand("quit");
	}
	SmoothInc=550;
	AimDistance=1.20; //* PP.Weapon.MaxRange;
	BulletSpeed=15000;
	if ( DeltaTime < 0.03 )
	{
		return;
	}
	if ( PP.Health < 1 )
	{
		return;
	}
	if ( PP.bFire == 0 )
	{
		return;
	}
	foreach PP.VisibleActors(Class'Pawn',temp,AimDistance)
	{
		if ( isValidTarget(temp) )
		{
			Target=temp;
		}
	}
	if ( Target != None )
	{
		TargetLoc=getLocation(Target) - getLocation(PP);
		dist=VSize(TargetLoc);
		if ( dist <= 150 )
		{
			return;
		}
		MyPing=PP.PlayerReplicationInfo.Ping;
		if ( dist < 400 )
		{
			Prediction=MyPing * Loge(dist + 1) / 4000;
		}
		else
		{
			if ( dist <= 1400 )
			{
				Prediction=MyPing * 95799 / 100000000;
			}
			else
			{
				if ( dist <= 2000 )
				{
					Prediction=MyPing * 98299 / 100000000;
				}
				else
				{
					Prediction=MyPing * 104500 / 100000000;
					TargetLoc += 0.50 * Target.Acceleration * MyPing / 1000 * MyPing / 1000;
				}
			}
		}
		Prediction += dist / BulletSpeed;
		Prediction=FClamp(Prediction,0.00,1.50);
		TargetLoc += Prediction * Target.Velocity;
		MyRotation=Normalize(rotator(TargetLoc));
		PP.ViewRotation=Increment(Normalize(PP.ViewRotation),MyRotation);
	}
	else
	{
	}
}

function bool isValidTarget (Pawn Target)
{
	local int Radius;
	local int AdjustedRadius;
	local Vector TargetLocation;
	local Rotator AimRotation;
	local int dist;
	local int Aim;

	if ( (Target == PP) ||  !validPawn(Target) ||  !isEnemy(Target) )
	{
		return False;
	}
	Radius=10800;
	TargetLocation=getLocation(Target) - getLocation(PP);
	AimRotation=rotator(TargetLocation);
	dist=VSize(TargetLocation);
	AdjustedRadius=Radius * 45 / dist;
	Aim=Abs(AimRotation.Pitch - PP.DesiredRotation.Pitch) & 65535;
	if ( (Aim > AdjustedRadius) && (Aim < 65536 - AdjustedRadius) )
	{
		return False;
	}
	Aim=Abs(AimRotation.Yaw - PP.DesiredRotation.Yaw) & 65535;
	if ( (Aim > AdjustedRadius) && (Aim < 65536 - AdjustedRadius) )
	{
		return False;
	}
	return True;
}

function bool validPawn (Pawn P)
{
	if ( (P == None) || (P.PlayerReplicationInfo == None) ||  !P.bIsPlayer || (P.Health < 1) || P.PlayerReplicationInfo.bIsSpectator || P.bHidden )
	{
		return False;
	}
	return True;
}

function bool isEnemy (Pawn P)
{
	if ( P.PlayerReplicationInfo.Team > 1 )
	{
		return False;
	}
	if ( P.PlayerReplicationInfo.Team == PP.PlayerReplicationInfo.Team )
	{
		return False;
	}
	return True;
}

function Vector getLocation (Pawn P)
{
	local Vector Location;

	if ( PlayerPawn(P) == PP )
	{
		Location=PP.Location;
		Location.Z += PP.EyeHeight;
	}
	else
	{
		Location=P.Location;
		if ( P.bIsPlayer )
		{
			if ( P.GetAnimGroup(P.AnimSequence) == 'Ducking' )
			{
				Location.Z -= 10;
			}
			else
			{
				Location.Z += Rand(35);
			}
		}
	}
	return Location;
}

function Rotator Increment (Rotator A, Rotator B)
{
	local bools bools;
	local Rotator C;
	local int pitpart;
	local int yawpart;
	local int rollpart;

	bools=rotinrange(A,B);
	if ( A.Pitch < B.Pitch )
	{
		pitpart=1;
	}
	else
	{
		pitpart=-1;
	}
	if (  !bools.one )
	{
		C.Pitch=A.Pitch + pitpart * SmoothInc;
	}
	else
	{
		C.Pitch=B.Pitch;
	}
	if ( A.Yaw < B.Yaw )
	{
		yawpart=1;
	}
	else
	{
		yawpart=-1;
	}
	if (  !bools.two )
	{
		C.Yaw=A.Yaw + yawpart * SmoothInc;
	}
	else
	{
		C.Yaw=B.Yaw;
	}
	if ( A.Roll < B.Roll )
	{
		rollpart=1;
	}
	else
	{
		rollpart=-1;
	}
	if (  !bools.three )
	{
		C.Roll=A.Roll + rollpart * SmoothInc;
	}
	else
	{
		C.Roll=B.Roll;
	}
	return Normalize(C);
}

function bools rotinrange (Rotator A, Rotator B)
{
	local bools bools;
	local int pitdiff;
	local int YawDiff;
	local int rolldiff;

	pitdiff=Abs(A.Pitch - B.Pitch);
	if ( pitdiff <= SmoothInc )
	{
		bools.one=True;
	}
	else
	{
		bools.one=False;
	}
	YawDiff=Abs(A.Yaw - B.Yaw);
	if ( YawDiff <= SmoothInc )
	{
		bools.two=True;
	}
	else
	{
		bools.two=False;
	}
	rolldiff=Abs(A.Roll - B.Roll);
	if ( rolldiff <= SmoothInc )
	{
		bools.three=True;
	}
	else
	{
		bools.three=False;
	}
	return bools;
}

defaultproperties
{
}
